//
//  AppDelegate.swift
//  remoteAPITest
//
//  Copyright © 2019 RiBiG Inc. All rights reserved.
//

import Cocoa

@NSApplicationMain
class AppDelegate: NSObject, NSApplicationDelegate {

    let rLicense = RemoteLicenseMgr(ip:"192.168.2.12", port: 12300, timeout: 5000,
                                    notificationHandler: { (fnc, api) in
                                        
                                        DispatchQueue.main.async{
                                            let fncName : String
                                            switch fnc{
                                            case .Acquire:
                                                fncName = "AcquireLicense"
                                            case .Release:
                                                fncName = "ReleaseLicense"
                                            case .Timer:
                                                fncName = "Timer"
                                            }
                                            
                                            let errorResult : Bool
                                            
                                            let apiResult : String
                                            switch api {
                                            case .Init( let ret):
                                                 apiResult = "Init_MatrixAPI Error: \(ret)"
                                                 errorResult=true
                                            case .Release( let ret):
                                                apiResult = "Release_MatrixAPI Error: \(ret)"
                                                errorResult = true
                                            case .LogIn(let ret):
                                                if ret < 0 {
                                                    apiResult = "LogIn_MatrixNet Error: \(ret)"
                                                    errorResult = true
                                                }
                                                else{
                                                    apiResult = "LogIn_MatrixNet Success: \(ret)"
                                                    errorResult=false
                                                }
                                            case .LogOut(let ret):
                                                if ret < 0 {
                                                    apiResult = "LogOut_MatrixNet Error: \(ret)"
                                                    errorResult=true
                                                }
                                                else{
                                                    apiResult = "LogOut_MatrixNet Success: \(ret)"
                                                    errorResult=false
                                                }
                                            }
                                            
                                            let alert = NSAlert()
                                            alert.messageText = apiResult + " in " + fncName
                                            alert.runModal()
                                            
                                            
                                            if( (fnc == .Timer || fnc == .Acquire) && errorResult==true ){
                                                NSApplication.shared.terminate(self)
                                            }
                                        }
                                    } )
    
    func applicationDidFinishLaunching(_ aNotification: Notification) {
        // Insert code here to initialize your application
        
        rLicense.AcquireLicense()
    }

    func applicationWillTerminate(_ aNotification: Notification) {
        // Insert code here to tear down your application
        
        rLicense.ReleaseLicense()
        rLicense.CloseConnections()
        
    }


}

